/**
 * Copyright (C) 2011 Agrosense <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.isobus.type;

import java.util.List;
import nl.cloudfarming.client.isobus.model.Comment;
import nl.cloudfarming.client.isobus.model.CommentValue;
import org.openide.nodes.ChildFactory;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.NbBundle;
import org.openide.util.NbBundle.Messages;

/**
 *
 * @author Gerben Feenstra
 */
@Messages("isobus.project.taskdata.node.name.commentvalue=CommentValue {0} - {1}")
public class CommentChildFactory extends ChildFactory<CommentValue> {

    private static final String COMMENTVALUE_NODE_ICON = "";
    
    private final Comment comment;
    
    public CommentChildFactory(Comment comment) {
        this.comment = comment;
    }
    
    @Override
    protected boolean createKeys(List<CommentValue> toPopulate) {
        toPopulate.addAll(comment.getCommentValues());
        return true;
    }

    @Override
    protected Node createNodeForKey(CommentValue commentValue) {
        String displayName = NbBundle.getMessage(CommentChildFactory.class, "isobus.project.taskdata.node.name.commentvalue", commentValue.getId(), commentValue.getDesignator());
        return new IsobusCommonNode(Children.LEAF, commentValue, COMMENTVALUE_NODE_ICON, displayName);
    }
}
